#!/usr/bin/perl

#   f i e l d s   o f   d r e a m
#
#   a project by nick montfort and rachel stevens
#   created for poems that go, october 2003
#   v1.0
#
# name=PLAYER 
# dream=TEXT
#
# if TEXT has *blanks* in it like *this*, create a dreamfield that
# is attributed to PLAYER on the links page, replacing the one
# indicated by the file named NEXT_NAME. if it doesn't have 
# blanks, output the dreamfield page again with the instructions
# about including blanks in bold. if TEXT exceeds 1200
# characters, truncate it to 1200, adding " . . ." at the end.
# log all submissions, creating the appropriate files fx.html and
# tx.html (where x = the dreamfield to be replaced) when the
# submission is valid

#use strict;
#use warnings;
require 5.0;

BEGIN { push(@INC,'.'); }
BEGIN { do 'settings.pl'; }
BEGIN { do 'utils.pl'; }

my $q = new CGI;
my %f = ();
my $name = $q->param("name");
my $story = $q->param("dream");

# it doesn't have to be a "story," really, it can be any text 
# with blanks in it. but $story is used to distinguish this from
# the texts provided when filling in fields.

my $date = localtime(time);
my @errors = ();
my $prelim_num;
my $num;

########################

$name = substr($name,0,30);
if (length($story) > 1200)
{
 $story = substr($story,0,1200);
 $story = $story + " . . .";
}

get_next();
log_story();

# are there any *blanks* in the story?
if (!($story =~ m/[\*][a-zA-Z0-9][^\*]*[\*]/))
{ push @errors, "noblanks"; }

# convert all < > to &lt; &gt;
$story =~ s/</&lt;/g;
$story =~ s/>/&gt;/g;
$name =~ s/</&lt;/g;
$name =~ s/>/&gt;/g;

if (scalar(@errors) == 0)
{ 
 log_update();
 save_fields();
 
 save_template();
 update_byline();
 print_ack();
}
else
{ ask_story_again(@errors); }

########################

sub get_next
{
 open NEXT_IN, "<" . LOG_PATH . NEXT_NAME;
 $prelim_num = <NEXT_IN>;
 close NEXT_IN;
}

sub log_story
{
 open LOGFILE, ">>" . LOG_PATH . LOG_NAME;
 print LOGFILE "ENTERING DREAMFIELD :::::::::::::::::::: \n";
 print LOGFILE "by: " . $name . "\n";
 print LOGFILE "may replace: " . $prelim_num;
 print LOGFILE $story . "\n";
 print LOGFILE "    entered " . $date. "\n";
 print LOGFILE "    by " . $q->remote_host . "\n\n";
 close LOGFILE;
}

sub log_update
{
 open NEXT_IN, "<" . LOG_PATH . NEXT_NAME;
 $num = <NEXT_IN>;
 if ($num =~ /(\d)/) # Needed to untaint $num
 { $num = "$1"; }
 close NEXT_IN;
 open NEXT_OUT, ">" . LOG_PATH . NEXT_NAME;
 print NEXT_OUT (($num+1)%10) . "\n";
 close NEXT_OUT;
 open LOGFILE, ">>" . LOG_PATH . LOG_NAME;
 print LOGFILE "REPLACING DREAMFIELD ::::::::::::::::::: \n";
 print LOGFILE "by: " . $name . "\n";
 print LOGFILE "replacing: " . $num . "\n";
 print LOGFILE $story . "\n";
 print LOGFILE "    entered " . $date. "\n";
 print LOGFILE "    by " . $q->remote_host . "\n\n";
 close LOGFILE;
}

sub save_fields
{
 my @fieldnames = $story =~ m/[\*]([a-zA-Z0-9][^\*]*)[\*]/g;

 # 'ooooo' is the same for the file parameter. if someone uses it as
 # a field name (which is very clever and funny, ha ha) convert it 
 # to 'oooooo' to avoid a conflict.
 $story =~ s/\*ooooo\*/\*oooooo\*/g;

 # " will go in html tags, convert all into &quot;
 foreach (@fieldnames)
 { s/"/&quot;/g; }

 # if there are duplicate fields (verb, verb) convert them to have
 # different numbers (verb 1, verb 2).
 foreach my $i (0 .. (scalar(@fieldnames)-1))
 {
  my $rename = 1;
  foreach my $j (($i+1) .. scalar(@fieldnames))
  {
   if ($fieldnames[$i] eq $fieldnames[$j])
   {
    $rename++;
    $fieldnames[$j] = $fieldnames[$j] . " " . $rename;
   }
  }
  my $oldex = quotemeta($fieldnames[$i]);
  my $old = $fieldnames[$i];
  $story =~ s/\*${oldex}\*/\*${old} 1\*/;
  for my $k (2 .. $rename)
  { 
   $story =~ s/\*${oldex}(\*)/\*${old} ${k}\*/;
  }
  $story =~ s/\*${oldex} 1\*/\*${old}\*/;
 }

 open FIELDS_OUT, ">" . TEMPLATE_PATH . "f" . $num . ".html";

 open TOP, "<" . TEMPLATE_PATH . TOP_TEMPLATE;
 while(<TOP>)
 { print FIELDS_OUT $_ };
 close TOP;

 print FIELDS_OUT "please provide</p>\n";
 print FIELDS_OUT "<form method=\"get\" action=\"/cgi-bin/fields/dream.pl\">\n";

 for my $fieldname (@fieldnames)
 {
  print FIELDS_OUT "<p><input type=\"text\" ";
  print FIELDS_OUT "name=\"" . $fieldname . "\" size=\"20\" />";
  print FIELDS_OUT " : " . $fieldname . "</p>\n"; 
 }

 print FIELDS_OUT "<p><input type=\"submit\" class=\"fancy\" ";
 print FIELDS_OUT "value=\" &gt;&gt;&gt; continue &gt;&gt;&gt; \" />\n";
 print FIELDS_OUT "<input type=\"hidden\" name=\"ooooo\" value=\"";
 print FIELDS_OUT $num . "\" /></p></form><p>";
 
 open BOTTOM, "<" . TEMPLATE_PATH . BOTTOM_TEMPLATE;
 while(<BOTTOM>)
 { print FIELDS_OUT $_ };
 close BOTTOM;
 
 close FIELDS_OUT;
}

sub save_template
{
 open TEMPLATE_OUT, my $template_name = ">" . TEMPLATE_PATH . "t" . $num . ".tpl";

 open TOP, "<" . TEMPLATE_PATH . TOP_TEMPLATE;
 while(<TOP>)
 { print TEMPLATE_OUT $_ };
 close TOP;

 print TEMPLATE_OUT $story . "\n";

 open BOTTOM, "<" . TEMPLATE_PATH . BOTTOM_TEMPLATE;
 while(<BOTTOM>)
 { print TEMPLATE_OUT $_ };
 close BOTTOM;

 close TEMPLATE_OUT;
}

sub update_byline
{
 open LINKS, "<" . TEMPLATE_PATH . LINKS_PAGE;
 my @linkpage = <LINKS>;
 close LINKS;
 open LINKS, ">" . TEMPLATE_PATH . LINKS_PAGE;
 if (!($name =~ m/[a-zA-Z0-9]/))
 { $name = "anon."; }
 for (@linkpage)
 {
 s/(\(${num}\) by ).*(<\/a>)/$1${name}$2/;
 print LINKS $_;
 }
 close LINKS;
}

sub print_ack
{
 print CGI_HEADER;
 open TOP, "<" . TEMPLATE_PATH . TOP_TEMPLATE;
 while(<TOP>)
 { print $_ };
 print "thank you! anyone can now <a href=\"emit.pl?file=f" . $num;
 print "\">populate your dreamfield.</a> it is (" . $num . "), and will ";
 print "remain available until ten other dreamfields are created, ";
 print "at which point it will sink into the web's unconscious.</p>\n";
 print "<p class=\"small\">you may return to the <a href=\"" . MAIN_PAGE;
 print "\">main menu . . .</a></p></a>\n";
 open BOTTOM, "<" . TEMPLATE_PATH . BOTTOM_TEMPLATE;
 while(<BOTTOM>)
 { print $_ };
}

sub ask_story_again
{
 print CGI_HEADER;
 open CREATE, "<" . TEMPLATE_PATH . "create.html";
 while(<CREATE>)
 {
  if ($_[0] eq "noblanks")
  {
   s/(with blanks to be filled in,)/<strong>$1<\/strong>/;
   s/([\*][a-zA-Z0-9]+[\*])/<strong>$1<\/strong>/g;
  }
  s/(name=\"dream\">)/$1${story}/;
  print $_;
 }
 close CREATE;
}
