#!/usr/bin/perl

#   f i e l d s   o f   d r e a m
#
#   a project by nick montfort and rachel stevens
#   created for poems that go, october 2003
#   v1.0
#
# field1=TEXT1
# field2=TEXT2
# ...
# fieldn=TEXTn
# ooooo=NUM
# 
# output dreamfield number NUM with field1 through fieldn filled
# in using TEXT1 through TEXTn if all have been provided. if not,
# return the appropriate fields page with text in bold to 
# indicate what is missing. update the log in all cases. truncate
# TEXT1 through TEXTn to 20 characters each to enforce the limits
# in the html form

#use strict;
#use warnings;
require 5.0;

BEGIN { push(@INC,'.'); }
BEGIN { do 'settings.pl'; }
BEGIN { do 'utils.pl'; }

my $q = new CGI;
my %f = ();
my @fieldnames = $q->param();
for my $fieldname (@fieldnames)
{
 $f{$fieldname} = $q->param($fieldname);
 $f{$fieldname} = substr($f{$fieldname},0,20);
 $f{$fieldname} =~ s/</&lt;/g;
 $f{$fieldname} =~ s/>/&gt;/g;
 }
my $date = localtime(time);
my @missing = ();

########################

log_entries();
for my $fieldname (@fieldnames)
{
 if (!($f{$fieldname} =~ m/[a-zA-Z0-9]/))
 { 
  push(@missing, $fieldname);
  $f{$fieldname} = "";
 }
}
if (scalar(@missing) == 0)
{ output_page(); }
else
{ ask_fields_again(); }

########################

sub log_entries
{
 open LOGFILE, ">>" . LOG_PATH . LOG_NAME;
 print LOGFILE "FILLING IN FIELDS :::::::::::::::::::::: \n";
 for my $fieldname (@fieldnames)
 { print LOGFILE $fieldname . " : " . $f{$fieldname} . "\n"; }
 print LOGFILE "    entered " . $date. "\n";
 print LOGFILE "    by " . $q->remote_host . "\n\n";
 close LOGFILE;
}

sub output_page
{
 print CGI_HEADER;
 my $left = (@fieldnames - 1);
 my @newdream = ();
 open TEMPLATE, "<" . TEMPLATE_PATH . "t" . $f{"ooooo"} . ".tpl";
 my $link = "<p class=\"small\">. . . why not " .
   "<a href=\"emit.pl?file=create\">create your own dreamfield</a> now? " . 
   "</p>\n<p class=\"small2\">or fill in fields again: ";
 for (0..9)
 {
  $link = $link . "<a href=\"emit.pl?file=f" . $_ . "\">(" . $_ . ")</a> \n";
 }
 $link = $link . " or go to the <a href=\"" . MAIN_PAGE . "\">" . 
   "main menu . . .</a>\n";
 while (<TEMPLATE>)
 {
  for my $fieldname (@fieldnames)
  { 
   my $new = $f{$fieldname};
   my $fieldex = quotemeta($fieldname);
   if (s/\*${fieldex}\*/<em>${new}<\/em>/)
   { $left--; };
  }
  s/(<\/body>)/${link}$1/;
  push( @newdream, $_ );
 }
 close TEMPLATE;
 if ($left > 0) # eep! this means someone changed the dreamfield
 {              # while this user was filling out fields
 ask_new_fields();
 }
 else
 {
  for (@newdream)
  { print $_; }
 }
}

sub ask_fields_again
{
 print CGI_HEADER;
 open FIELDS, "<" . TEMPLATE_PATH . "f" . $f{"ooooo"} . ".html";
 while(<FIELDS>)
 {
  for my $fieldname (@fieldnames)
  {
   my $newex = quotemeta($f{$fieldname});
   my $fieldex = quotemeta($fieldname);
   if (s/(name=\"${fieldex}\")/$1 value=\"${newex}\"/)
   {
    if ($f{$fieldname} eq "")
    { s/> :([^<]+)</><strong> : $1<\/strong></ }
   }
  } 
  print $_;
 }
 close FIELDS;
}

sub ask_new_fields
{
 my $newnote = "<strong>this dreamfield changed while you were filling in " .
  "your texts!</strong></p>\n<p>sorry. write quickly, automatically &mdash; " .
  "you'll hopefully see the results this time.</p>\n<p>";
 open FIELDS, "<" . TEMPLATE_PATH . "f" . $f{"ooooo"} . ".html";
 while(<FIELDS>)
 {
  s/(please provide<\/p>)/${newnote}$1/;
  print $_;
 }
 close FIELDS;
}
